document.write('<script type="text/javascript" src="' + path_public + 'js/tiny_mce/tiny_mce.js"></script>');

/**
 * TinyMCE 初期化オプション
 * @var object
 */
var objTinymceInitOption = {
	// 共通設定
	'default' :
	{
		mode                              : 'exact',
		/*
		 * C-Unit 2011-10-25 Start
		 * #5596
		 * Translation
		 */
		//language                          : 'ja',
		language						  : language,
		/*
		 * C-Unit 2011-10-25 End
		 */
		width                             : '100%',
		content_css                       : path_public + 'css/tinymce.css,' + path_system_user_root + '../common_files/css/preview.css',
		force_p_newlines                  : false,
		//valid_elements					  : "*[*]",
		theme                             : 'advanced',
		theme_advanced_layout_manager     : 'SimpleLayout',
		theme_advanced_toolbar_align      : 'left',
		theme_advanced_toolbar_location   : 'top',
		theme_advanced_statusbar_location : 'bottom',
		theme_advanced_buttons1           : '',
		theme_advanced_buttons2           : '',
		theme_advanced_buttons3           : '',
		extended_valid_elements           : "iframe[src|style|width|height|scrolling|marginwidth|marginheight|frameborder],object[class|type|border|alt|title|hspace|vspace|width|height|align|onmouseover|onmouseout|name|ref],img[class|src|border|alt|title|hspace|vspace|width|height|align|onmouseover|onmouseout|name|ref]"
	},

	// 静的ページ
	'contents' :
	[
		{
			height                            : 450,

			// tinymce にする ID をカンマ区切りで指定
			elements                          : "content_full",
			plugins                           : "inlinepopups,insertblock,table,contextmenu,searchreplace,media,style,layer,save,contextmenu,paste,template",
			//theme_advanced_buttons1           : "formatselect,fontselect,fontsizeselect,forecolor,bold,italic,insertdate,underline,strikethrough,link,unlink,separator,bullist,numlist,outdent,indent,image,cms_media,separator,hr,table,code,cms_file,anchor,separator,undo,redo,separator,insertlayer,moveforward,movebackward,absolute,template,separator,pasteword,styleprops,separator,twitter,facebook,youtube,google",
			theme_advanced_buttons1           : "formatselect,fontselect,fontsizeselect,forecolor,bold,italic,insertdate,underline,strikethrough,link,unlink,separator,bullist,numlist,outdent,indent,image,cms_media,separator,hr,styleprops,table,code,anchor",
			theme_advanced_buttons2           : "cms_file,undo,redo,separator,insertlayer,moveforward,movebackward,absolute,template,separator,pasteword,styleprops,separator,twitter,facebook,youtube,google",

			file_browser_callback             : 'imceFileBrowser',

			theme_advanced_resizing           : true,
			theme_advanced_resize_horizontal  : true,
//			extended_valid_elements           : "iframe[*],img[*],form[*]",
			extended_valid_elements           : "*[*]",
			remove_linebreaks 				  : false,
			convert_urls                      : false
		},
		{
			height                            : 400,

			// tinymce にする ID をカンマ区切りで指定
			elements                          : "contents",
			plugins                           : "inlinepopups,insertblock,table,contextmenu,searchreplace,media,style,layer,save,contextmenu,paste,template",
			theme_advanced_buttons1           : "formatselect,fontselect,fontsizeselect,forecolor,bold,italic,insertdate,underline,strikethrough,link,unlink,separator,bullist,numlist,outdent,indent,image,cms_media,separator,hr,styleprops,table",
			theme_advanced_buttons2           : "code,cms_file,anchor,undo,redo,separator,insertlayer,moveforward,movebackward,absolute,template,separator,pasteword,styleprops,separator,twitter,facebook,youtube,google",
			file_browser_callback             : 'imceFileBrowser',

			theme_advanced_resizing           : true,
			theme_advanced_resize_horizontal  : false,
//			extended_valid_elements           : "iframe[*],img[*],form[*]",
			extended_valid_elements           : "*[*]",
			remove_linebreaks 				  : false,
			convert_urls                      : false
		}
	],
	
	// 静的ページ
	'contents_smp' :
	[
		{
			height                            : 600,

			// tinymce にする ID をカンマ区切りで指定
			elements                          : "contents_full",
			plugins                           : "inlinepopups,insertblock,table,contextmenu,searchreplace,media,layer,save,contextmenu,paste,template",
			theme_advanced_buttons1           : "formatselect,fontsizeselect,forecolor,bold,italic,insertdate,underline,strikethrough,link,unlink,separator,bullist,numlist,outdent,indent,image,cms_media,separator,hr,table,code,cms_file,anchor,separator,undo,redo,separator,insertlayer,moveforward,movebackward,absolute,template,separator,pasteword,styleprops,separator,twitter,facebook,youtube,google",

			file_browser_callback             : 'imceFileBrowser',

			theme_advanced_resizing           : true,
			theme_advanced_resize_horizontal  : true,
//			extended_valid_elements           : "iframe[*],img[*],form[*]",
			extended_valid_elements           : "*[*]",
			//remove_linebreaks 				  : false,
			//convert_urls                      : false,
			theme_advanced_statusbar_location : ''
		},
		{
			height                            : 518,
			width : 326,
			// tinymce にする ID をカンマ区切りで指定
			elements                          : "contents",
			plugins                           : "pdw,inlinepopups,insertblock,table,contextmenu,searchreplace,media,layer,save,contextmenu,paste,template",
			theme_advanced_buttons1           : "pdw_toggle,formatselect,fontsizeselect,forecolor,bold,italic,insertdate,underline,strikethrough",
			theme_advanced_buttons2           : "bullist,numlist,outdent,indent,separator,justifyleft,justifycenter,justifyright,justifyfull,separator,hr,table,anchor,undo,redo",
			theme_advanced_buttons3           : "insertlayer,moveforward,movebackward,absolute,template,styleprops,separator,twitter,facebook,youtube,google,separator,image,cms_media,cms_file,separator,code",
			
			theme_advanced_toolbar_location	  : "top",
			theme_advanced_toolbar_align	  : "left",
		//	file_browser_callback             : 'imceFileBrowser',

	//		theme_advanced_resizing           : true,
			theme_advanced_resize_horizontal  : false,
//			extended_valid_elements           : "iframe[*],img[*],form[*]",
			extended_valid_elements           : "*[*]",
			remove_linebreaks 				  : false,
			convert_urls                      : false,
			theme_advanced_statusbar_location : '',
			
			pdw_toggle_on 					  : "1",
			pdw_toggle_toolbars				  : "2,3"
		}
	],
	// TinyMCEテンプレートブロック
	'block' :
	[
		{
			// tinymce にする ID をカンマ区切りで指定
			elements                          : "text",
			plugins                           : "inlinepopups,insertblock,table,contextmenu,searchreplace,media,style,layer,save,contextmenu,paste,template",
			theme_advanced_buttons1           : "formatselect,fontselect,fontsizeselect,forecolor,bold,italic,insertdate,underline,strikethrough,link,unlink,separator,bullist,numlist,outdent,indent,image,cms_media,separator,hr,styleprops,table",
			theme_advanced_buttons2           : "code,cms_file,anchor,undo,redo,separator,insertlayer,moveforward,movebackward,absolute,template,separator,pasteword,styleprops,separator,twitter,facebook,youtube,google",
			file_browser_callback             : 'imceFileBrowser',

			theme_advanced_resizing           : true,
			theme_advanced_resize_horizontal  : false,

			extended_valid_elements			  : "*[*]",
			convert_urls                      : false,
			remove_linebreaks 				  : false
			//apply_source_formatting			  : false
		},
		{
			height                            : 400,

			// tinymce にする ID をカンマ区切りで指定
			elements                          : "block_text_full",
			plugins                           : "inlinepopups,insertblock,table,contextmenu,searchreplace,media,style,layer,save,contextmenu,paste,template",
			theme_advanced_buttons1           : "formatselect,fontselect,fontsizeselect,forecolor,bold,italic,insertdate,underline,strikethrough,link,unlink,separator,bullist,numlist,outdent,indent,image,cms_media,separator,hr,styleprops,table",
			theme_advanced_buttons2           : "code,cms_file,anchor,undo,redo,separator,insertlayer,moveforward,movebackward,absolute,template,separator,pasteword,styleprops,separator,twitter,facebook,youtube,google",
			file_browser_callback             : 'imceFileBrowser',

			theme_advanced_resizing           : true,
			theme_advanced_resize_horizontal  : true,

			extended_valid_elements			  : "*[*]",
			convert_urls                      : false,
			remove_linebreaks 				  : false
			//apply_source_formatting			  : false
		}
	],

	// 自動生成ページ
	'item' :
	[
		{
			// tinymce にする ID をカンマ区切りで指定
			elements                          : '',
			plugins                           : "inlinepopups,insertblock,table,contextmenu,searchreplace,media,style,layer,save,contextmenu,paste,template",
			theme_advanced_buttons1           : "formatselect,fontselect,fontsizeselect,forecolor,bold,italic,insertdate,underline,strikethrough,link,unlink,separator,bullist",
			theme_advanced_buttons2           : "numlist,outdent,indent,image,cms_media,separator,hr,styleprops,table,code,cms_file,anchor,undo,redo,separator,insertlayer,moveforward,movebackward,absolute,template,separator,pasteword,styleprops",			
			file_browser_callback             : 'imceFileBrowser',

			theme_advanced_resizing           : true,
			theme_advanced_resize_horizontal  : false,
			convert_urls                      : false,
			remove_linebreaks 				  : false,

//			extended_valid_elements           : "iframe[*],img[*]",
			extended_valid_elements			  : "*[*]",
			convert_urls                      : false
		}
	],

	// What'sNew
	'news' :
	[
		// １つ目
		{
			elements                          : "name,text",
			plugins                           : "inlinepopups,table",
			theme_advanced_buttons1           : "forecolor,bold",
			remove_linebreaks 				  : true,
			theme_advanced_statusbar_location : ''
		},
		// ２つ目
		{
			elements                          : "data_detail",
			plugins                           : "inlinepopups,insertblock,table,contextmenu,searchreplace,media,style,layer,save,contextmenu,paste,template",
			theme_advanced_buttons1           : "fontselect,fontsizeselect,forecolor,backcolor,separator,bold,italic,underline,strikethrough,separator,link,unlink,separator,justifyleft",
			theme_advanced_buttons2           : "justifycenter,justifyright,justifyfull,separator,bullist,numlist,separator,styleprops,table,code,anchor,undo,redo,separator,insertlayer,moveforward,movebackward,absolute,template,separator,pasteword,styleprops,separator",
			theme_advanced_buttons3           : "twitter,facebook,youtube,google,separator,image,cms_media,cms_file",
			file_browser_callback             : 'imceFileBrowser',

			theme_advanced_resizing           : true,
			theme_advanced_resize_horizontal  : false,
			extended_valid_elements           : "*[*]",
			convert_urls                      : false,
			remove_linebreaks 		  : false
			//theme_advanced_statusbar_location : ''
		}
	],
		// item display place
	'item_display_place' :
	[
		{
			// tinymce にする ID をカンマ区切りで指定
			elements                          : '',
			plugins                           : "inlinepopups,insertblock,table,contextmenu,searchreplace,media,layer,save,contextmenu,paste,template",
			theme_advanced_buttons1           : "formatselect,fontsizeselect,forecolor,bold,italic,insertdate,underline,strikethrough,link,unlink,separator,bullist,numlist,outdent,indent,image,cms_media",
			theme_advanced_buttons2           : "hr,table,code,cms_file,anchor,undo,redo,separator,insertlayer,moveforward,movebackward,absolute,template,separator,pasteword,styleprops",
			file_browser_callback             : 'imceFileBrowser',

			theme_advanced_resizing           : true,
			theme_advanced_resize_horizontal  : false,
			convert_urls                      : false,
			remove_linebreaks 				  : false,

//			extended_valid_elements           : "iframe[*],img[*]",
			convert_urls                      : false
		}
	]
}

/**
 * TinyMCE 初期化定義
 * @param string name          ページの名前
 * @param string callback_name TinyMCE 初期化完了後に呼び出す関数の名前
 */
function cms_tinymce_init(name, callback_name) {
	// ３つ目以降の引数は TinyMCE 初期化オプションを指定出来る。
	// 複数 TinyMCE 作成する場合は４つ目以降も指定出来る。
	var i, key;
	for (i = 0; i < objTinymceInitOption[name].length; i ++) {
		// 引数指定があるか？
		if ('undefined' == typeof(arguments[i + 2])) {
			break;
		}
		// オプション上書き
		for (key in arguments[i + 2]) {
			objTinymceInitOption[name][i][key] = arguments[i + 2][key];
		}
	}

	// 初期化を遅延で呼び出す
	//   TinyMCE は初期化タイミングを遅らせたりしているらしい。
	//   jQuery で DOM 構築後に呼び出し、さらにそこから setTimeout で遅らせて呼び出す。
	jQuery(function() {
		setTimeout('tiny_mce_init("' + name + '", "' + callback_name + '");', 10);
	});
}

/**
 * TinyMCE 初期化
 * @param string name          ページの名前
 * @param string callback_name TinyMCE 初期化完了後に呼び出す関数の名前
 */
function tiny_mce_init(name, callback_name) {
	// ここに来ても tinymce/tinyMCE が存在しない可能性がある。
	// 存在していない場合は setTimeout で遅らせて呼び出す。
	if ('undefined' == typeof(tinymce) || 'undefined' == typeof(tinyMCE)) {
		setTimeout('tiny_mce_init();', 100);
		return;
	}	
	var i, key;
	var option;
	for (i = 0; i < objTinymceInitOption[name].length; i ++) {		
		// オプション更新
		option = {};
		for (key in objTinymceInitOption['default']) {
			option[key] = objTinymceInitOption['default'][key];
		}
		for (key in objTinymceInitOption[name][i]) {
			option[key] = objTinymceInitOption[name][i][key];
		}
		objTinymceInitOption[name][i] = option;

		// カスタムボタン追加
		objTinymceInitOption[name][i]['setup'] = function(ed) {
			// リンクの挿入
			ed.addButton('cms_file', {
				title   : objTranslation.gettext('tinymce_init_msg1'),
				image   : path_public + 'images/tinymce_file.gif',
				onclick : function() {
					var bookmark = ed.selection.getBookmark();
					nj('media_panel').attr('callback', function(name, file, id, target) {
						ed.selection.moveToBookmark(bookmark);
						tinymce.EditorManager.execCommand('blockcontents', path_userfile + file + "\t" + target, name);
					});
					// Hide all TinyMCE editor in current layer before showing a new flash layer
					hideTinyMceEditor();
					this.focus();
					nj('media_panel').open({type:'file'});
					image_resize_init(1);
				}
			});

			// 画像の挿入
			ed.addButton('image', {
				title   : objTranslation.gettext('tinymce_init_msg2'),
				onclick : function() {
					var bookmark = ed.selection.getBookmark();
					var strNode = ed.selection.getNode().nodeName;								
					nj('media_panel').attr('callback', function(name, file, id) {
						var tag = '<img src="' + path_userfile + file + '" alt="' + name + '" />';		
						ed.selection.moveToBookmark(bookmark);
						if(strNode == 'IMG') {	
							ed.execCommand('mceReplaceContent', false, tag);
							/*
							var strContents = tinyMCE.editors['contents'].getContent();														
							e = ed.selection.getNode();
							strSrc =  ed.dom.getAttrib(e, 'src');
							strTitle =  ed.dom.getAttrib(e, 'title');
							strAlt =  ed.dom.getAttrib(e, 'alt');
							strContents = strContents.replace( strSrc, path_userfile + file);
							strContents = strContents.replace( strTitle,"");
							strContents = strContents.replace( strAlt,name);
							tinyMCE.editors['contents'].setContent('');
							tinymce.EditorManager.execCommand('blockdirect',strContents);	
							*/						
						} else {
							tinymce.EditorManager.execCommand('blockdirect', tag);
						}
						//tinymce.EditorManager.execCommand('blockdirect', tag);					
					});
					
					// Hide all TinyMCE editor in current layer before showing a new flash layer
					hideTinyMceEditor();
					this.focus();

					nj('media_panel').open({type:'image'});
					image_resize_init(1);
				}
			});

			// 動画の挿入（追加）
			ed.addButton('cms_media', {
				title   : objTranslation.gettext('tinymce_init_msg3'),
				image   : path_public + 'images/tinymce_media.gif',
				onclick : function() {
					var bookmark = ed.selection.getBookmark();
					nj('media_panel').attr('callback', function(name, file, id) {
						// 動画表示タグ定義
						var objMovieOption = {
							dcr : {
								classid  : 'clsid:166b1bca-3f9c-11cf-8075-444553540000',
								codebase : 'http://download.macromedia.com/pub/shockwave/cabs/director/sw.cab#version=8,5,1,0',
								type     : 'application/x-director',
								param    : {
									sound           : 'true',
									progress        : 'true',
									autostart       : 'true',
									swstretchstyle  : 'none',
									swstretchhalign : 'none',
									swstretchvalign : 'none'
								},
								embed : {
									swliveconnect : false
								}
							},
							mov : {
								classid  : 'clsid:02bf25d5-8c17-4b23-bc80-d3488abddc6b',
								codebase : 'http://www.apple.com/qtactivex/qtplugin.cab#version=6,0,2,0',
								type     : 'video/quicktime',
								param : {},
								embed : {}
							},
							ram : {
								classid  : 'clsid:cfcdaa03-8be4-11cf-b84b-0020afbbccfa',
								codebase : 'http://download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=6,0,40,0',
								type     : 'audio/x-pn-realaudio-plugin',
								param : {},
								embed : {}
							},
							swf : {
								classid  : 'clsid:d27cdb6e-ae6d-11cf-96b8-444553540000',
								codebase : 'http://download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=6,0,40,0',
								type     : 'application/x-shockwave-flash',
								param : {},
								embed : {}
							},
							wmv : {
								classid  : 'clsid:6bf52a52-394a-11d3-b153-00c04f79faa6',
								codebase : 'http://activex.microsoft.com/activex/controls/mplayer/en/nsmp2inf.cab#Version=5,1,52,701',
								type     : 'application/x-mplayer2',
								param : {},
								embed : {}
							}
						}

						// 拡張子
						var ext = file.split('.');
						ext = ext[ext.length - 1];
						if ('undefined' == typeof(objMovieOption[ext])) {
							ext = 'wmv';
						}

						var key;
						objMovieOption[ext].param.src = file;
						objMovieOption[ext].embed.src = file;
						if ('wmv' == ext) {
							objMovieOption[ext].embed.url = file;
						}
						objMovieOption[ext].embed.width = '100';
						objMovieOption[ext].embed.height = '100';
						objMovieOption[ext].width = '100';
						objMovieOption[ext].height = '100';

						var tag = '';
						tag += '<object';
						tag += ' width="' + objMovieOption[ext].width + '"';
						tag += ' height="' + objMovieOption[ext].height + '"';
						tag += ' classid="' + objMovieOption[ext].classid + '"';
						tag += ' codebase="' + objMovieOption[ext].codebase + '"';
						tag += '>';

						for (key in objMovieOption[ext].param) {
							tag += '<param name="' + key + '" value="' + objMovieOption[ext].param[key] + '" />';
						}

						tag += '<embed';
						for (key in objMovieOption[ext].embed) {
							tag += ' ' + key + '="' + objMovieOption[ext].embed[key] + '"';
						}
						tag += '></embed>';
						tag += '</object>';
						
						ed.selection.moveToBookmark(bookmark);

						tinymce.EditorManager.execCommand('blockdirect', tag);
					});

					// Hide all TinyMCE editor in current layer before showing a new flash layer
					hideTinyMceEditor();
					this.focus();

					nj('media_panel').open({type:'movie'});
					image_resize_init(1);
				}
			});

			ed.addButton('facebook', {
				title 	: objTranslation.gettext('tinymce_init_msg4'),
				image 	: path_public + 'images/admin/fb-icon.gif',
				onclick : function() {
					
					var bookmark = ed.selection.getBookmark();
					nj('facebook_panel').attr('callback', function(tag) {
						ed.selection.moveToBookmark(bookmark);
						tinymce.EditorManager.execCommand('blockdirect', tag);					
					});
					// Hide all TinyMCE editor in current layer before showing a new Facebook layer
					hideTinyMceEditor();
					this.focus();
					nj('facebook_panel').open({type:'image', form:null});
					facebook_init();
					hideTinyMceEditor(); 
					return false;
				}
			});
			ed.addButton('youtube', {
				title   : objTranslation.gettext('tinymce_init_msg5'),
				image   : path_public + 'images/tinymce_youtube.gif',
				onclick : function() {
					var bookmark = ed.selection.getBookmark();
					nj('youtube_panel').attr('callback', function(tag) {
						ed.selection.moveToBookmark(bookmark);
						tinymce.EditorManager.execCommand('blockdirect', tag);					
					});
					// Hide all TinyMCE editor in current layer before showing a new Youtube layer
					hideTinyMceEditor();
					this.focus();
					nj('youtube_panel').open();
					var strSelText = '';
					var strSelTextFormat = '';
					if(ed.getContent() != '')
					{
						strSelText = tinyMCE.activeEditor.selection.getContent();
						strSelTextFormat = tinyMCE.activeEditor.selection.getContent({format : 'text'});
					}
					youtube_init(strSelText, strSelTextFormat);
				}
			});

			// Add button linked to Google Map
			ed.addButton('google', {
				title 	: objTranslation.gettext('tinymce_init_msg6'),
				image 	: path_public + 'images/tinymce_google.gif',
				onclick : function() {
					var bookmark = ed.selection.getBookmark();
					nj('google_panel').attr('callback', function(strSrc, intWidth, intHeight) {
						var tag = '<iframe src="' + strSrc + ' " width="' + intWidth + '" height="' + intHeight + '" frameborder="no" scrolling="no" style="overflow:hidden"></iframe>';
						ed.selection.moveToBookmark(bookmark);
						tinymce.EditorManager.execCommand('blockdirect', tag);					
					});

					// Hide all TinyMCE editor in current layer before showing a new Google layer
					hideTinyMceEditor();
					//this.focus();
					// Add you own code to execute something on click
					showGoogleView();
				}
			});

			ed.addButton('twitter', {
				title 	: objTranslation.gettext('tinymce_init_msg7'),
				image 	: path_public + 'images/admin/tw_icon.gif',
				onclick : function() {
					var bookmark = ed.selection.getBookmark();
					nj('twitter_panel').attr('callback', function(tag) {
						ed.selection.moveToBookmark(bookmark);
						tinymce.EditorManager.execCommand('blockdirect', tag);					
					});
					// Hide all TinyMCE editor in current layer before showing a new Twitter layer
					hideTinyMceEditor();
					this.focus();
					// Show Twitter panel
					showTwitterView();
				}
			});
			
			ed.onClick.add(function(ed, e) {
				if(controller =='news' && ed.id == 'name')
					strKeepTitle = tinyMCE.get('name').getContent();
			});
			
			ed.onChange.add(function(ed, e) {
				if(controller =='news' && ed.id == 'name')
					changeTitle(this,'data_detail');
			});			
		}

		// TinyMCE 初期化
		tinyMCE.init(objTinymceInitOption[name][i]);
	}

	// コールバック呼び出し
	eval(callback_name + '()');
}

function imceFileBrowser(fid, url, type, win) {
	switch (type) {
		// Add image background into table
		// pop-up image for table
		case 'image':
			nj('media_panel').attr('callback', function(name, file, id) {
			
				jQuery("#mceModalBlocker").show();
				win.document.getElementById(fid).value = file;
				win.document.getElementById(fid).onchange();
			});

			nj('media_panel').open({type:'image'});
			jQuery("#mceModalBlocker").hide();
			image_resize_init(1);
			break;
		// リンク先選択
		case 'file':
			jQuery("#link_container").css("z-index","350000");
			nj('link_panel').open({callback:'setLinkHref', form:fid});
			link_init();
			jQuery(".nj-panel-mask").hide();

			//win.open(path_system + controller + '/linkview', '', 'width=720,height=740,resizable=1,scrollbars=1');
			break;
	}
}

/**
 * Set link value
 * @param string strValue
 * @param string strFormId
 */
function setLinkHref(strValue, strFormId)
{
	var iFrames = document.getElementsByTagName('iframe');
	jQuery(iFrames).contents().find("body #" + strFormId).val(strValue);
}

/**
 * TinyMCE ブロック挿入プラグインの初期化
 * @param object ed
 * @param string url
 */
function cms_insert_block_init(ed, url) {
	ed.addCommand(
		'block' + 'contents',
		function() {
			var name;
			if ('' == ed.selection.getContent()) {
				name = arguments[1];
			} else {
				name = ed.selection.getContent();
			}
			arguments[0] = arguments[0].split("\t");

			var href = arguments[0][0];
			var target = '';
			if ('' != arguments[0][1]) {
				target = ' target="' + arguments[0][1] + '"';
			}

			var data = '<a href="' + href + '"' + target + '>' + name + '</a>';
			ed.execCommand('mceInsertContent', false, data);
		}
	);

	ed.addCommand('block' + 'direct',      function() {ed.execCommand('mceInsertContent', false, arguments[0]);});
	/**
	 * C-Unit 2011-10-25 Start
	 * #5589
	 * Change all tag to english
	 */
	ed.addCommand('block' + 'news',        function() {ed.execCommand('mceInsertContent', false, '{' + arguments[0] + '＠WhatsNew}');});
	ed.addCommand('block' + 'logininfo',   function() {ed.execCommand('mceInsertContent', false, '{' + arguments[0] + '＠Login}');});
	ed.addCommand('block' + 'sitesearch',  function() {ed.execCommand('mceInsertContent', false, '{' + arguments[0] + '＠SiteSearch}');});
	ed.addCommand('block' + 'pankuzu',     function() {ed.execCommand('mceInsertContent', false, '{' + arguments[0] + '＠TopicPath}');});
	ed.addCommand('block' + 'sitemap',     function() {ed.execCommand('mceInsertContent', false, '{' + arguments[0] + '＠SiteMap}');});
	ed.addCommand('block' + 'itemview',    function() {ed.execCommand('mceInsertContent', false, '{' + arguments[0] + '＠DynamicList}');});
	ed.addCommand('block' + 'itemsearch',  function() {ed.execCommand('mceInsertContent', false, '{' + arguments[0] + '＠DynamicSearch}');});
	ed.addCommand('block' + 'inquiry',     function() {ed.execCommand('mceInsertContent', false, '{' + arguments[0] + '＠Contact}');});
	ed.addCommand('block' + 'userinfo',    function() {ed.execCommand('mceInsertContent', false, '{' + arguments[0] + '＠UserInfo}');});
	ed.addCommand('block' + 'menu',        function() {ed.execCommand('mceInsertContent', false, '{' + arguments[0] + '＠Menu}');});
	ed.addCommand('block' + 'owner_name',  function() {ed.execCommand('mceInsertContent', false, '{' + arguments[0] + '＠OwnerName}');});
	ed.addCommand('block' + 'greetings',   function() {ed.execCommand('mceInsertContent', false, '{' + arguments[0] + '＠Greetings}');});

	/*
	ed.addCommand('block' + 'logininfo',   function() {ed.execCommand('mceInsertContent', false, '{' + arguments[0] + '＠ログイン情報}');});
	ed.addCommand('block' + 'sitesearch',  function() {ed.execCommand('mceInsertContent', false, '{' + arguments[0] + '＠サイト内検索}');});
	ed.addCommand('block' + 'pankuzu',     function() {ed.execCommand('mceInsertContent', false, '{' + arguments[0] + '＠ぱんくず}'    );});
	ed.addCommand('block' + 'sitemap',     function() {ed.execCommand('mceInsertContent', false, '{' + arguments[0] + '＠サイトマップ}');});

	ed.addCommand('block' + 'itemview',    function() {ed.execCommand('mceInsertContent', false, '{' + arguments[0] + '＠自動生成一覧}');});
	ed.addCommand('block' + 'itemsearch',  function() {ed.execCommand('mceInsertContent', false, '{' + arguments[0] + '＠自動生成検索}');});

	ed.addCommand('block' + 'inquiry',     function() {ed.execCommand('mceInsertContent', false, '{' + arguments[0] + '＠お問い合わせ}');});
	ed.addCommand('block' + 'menu',        function() {ed.execCommand('mceInsertContent', false, '{' + arguments[0] + '＠メニュー}'    );});
	*/
	/*
	 * C-Unit 2011-10-25 End
	 */

	ed.addCommand('block' + 'layout',      function() {ed.execCommand('mceInsertContent', false, arguments[0]);});
	
	ed.addCommand('block' + 'designpart',      function() {ed.execCommand('mceInsertContent', false, arguments[0]);});
}

/**
 * Get process image data (merge data getting from Server and Client)
 */
function getProcessImageData(objDataClient, objDataServer) {
	var strResult = objDataClient['content'];

	for (i = 0; i < objDataServer.length; i++) {
		var strImage = objDataClient['listImages'][objDataServer[i].key];

		var currentLink = strImage;

		// Wrap hyperlink outside image if the alt is not empty
		if (objDataServer[i].alt != '') {
			currentLink = createHyperlink(strImage,path_public_user +'images/public/'+ objDataServer[i].url, objDataServer[i].alt);
		}
		strResult = strResult.replace(objDataServer[i].key, currentLink);
	}

	return strResult;
}

/**
 * 画像リックを作成する
 * @param string 画像タグ
 * return string 画像がリンクつき
 */
function createImageData(str) {
	var strResult = str;
	var replacePos = 0;

	// The array for storing temporatory data
	var objData = new Array();

	// The array contains all result collected data
	var objResult = new Array();
	objResult['listImages'] = new Array();

	// The string about image alias
	// (Each alias will match with pattern [alt="<alias>.])
	var strAliasResult = '';
	var strCombine = '';

	// Collect all hyperlinks
	do {
		// Get hyperlink content
		strLink = extractData(strResult, '<a', '</a>');
		if (strLink == null) {
			break;
		}

		var key = '${HYPERLINK}' + replacePos;
		strResult = strResult.replace(strLink, key);
		objData.push(new Object({'key' : key, 'value' : strLink}));

		replacePos++;
	} while (strLink != null);

	// Collect all image and put hyperlink into it
	do {
		strImage = extractData(strResult, '<img', '/>');
		if (strImage == null) {
			break;
		}
		var key = '${IMAGE}' + replacePos;
		strResult = strResult.replace(strImage, key);
		// Create image alias	
		strAlias = extractData(strImage, 'alt="', '"');
		strAlias = strAlias.replace('alt="', '').replace('"', '');
		if (strAlias == '') {
			strAlias = 'Othersize_of_';
		}
		strAlias = key + '#' + strAlias;
		strAliasResult += (strCombine + strAlias);
		strCombine = ',';

		// Put current image into result list
		objResult['listImages'][key] = strImage;

		replacePos++;
	} while (strImage != null);

	objResult['strAlias'] = strAliasResult;

	// Get the original content with keeping hyperlinks
	for (i = 0; i < objData.length; i++) {
		strResult = strResult.replace(objData[i].key, objData[i].value);
	}
	objResult['content'] = strResult;	
	return objResult;
}


/**
 * aタグを作成
 * @param string strImage 画像
 * @param string url リンク
 * @param string alt 画像のalt
 * return string url リンク
 */
function createHyperlink(strImage, url, alt) {
	strAlias = extractData(strImage, 'Othersize_of_', '"');
	if (strAlias == null)
	{
		var newImage = strImage.replace('/>', ' border="0" />');
		strSrc = url;
	}
	else
	{
		var strSrc = extractData(strImage, 'src="', '"');
		var strAlt = extractData(strImage, 'alt="', '"');
	
		var newImage = strImage.replace('/>', ' border="0" />');
		newImage = newImage.replace(strSrc, 'src="' + url + '"');
		newImage = newImage.replace(strAlt, 'alt="' + alt + '"');
	}

	var strHyperlink = '<a href=' + strSrc.replace('src=', '')
		+ ' target="_blank">' + newImage + '</a>';		
	return strHyperlink;
}

/**
 * Extract data from input string between range [strStart, strEnd]
 * @param string 文字
 * @param string 開始
 * @param string 終了
 */
function extractData(str, strStart, strEnd) {
	var startPos = str.indexOf(strStart);
	if (startPos < 0) {
		return null;
	}

	var endPos = str.indexOf(strEnd, startPos + strStart.length);
	if (endPos < 0) {
		return null;
	}
	var strImg = str.substring(startPos, endPos+strEnd.length);
	return strImg;
}

/**
 * 通常画像検索する
 * エーディタの内容を編集
 */
function replaceImage() {
	ed = tinyMCE.activeEditor;
	if (ed == undefined || ed == null) {
		return;
	}

	var strContent = ed.getContent();
	var objContent = createImageData(strContent);
	var urlRequest = path_system + 'contents/searchimg';

	// Call to server for getting search content by using AJAX, return value in JSON format
	jQuery.post(urlRequest,
		{
			strAlias : objContent['strAlias']
		}
		,function(data)
		{
			if(data != "") {
				var strResult = getProcessImageData(objContent, data);
				ed.setContent(strResult);
			}
		}, 'json'
	);
}

function youtube_content() {
	ed = tinyMCE.activeEditor;
	if (ed == undefined || ed == null) {
		return;
	}
	if(strSelectionEditor != ''){
		ed.execCommand('mceReplaceContent', false, strHtml);
		/*var strHtml = ed.getContent();

		//if(strSelectionEditor=='') strHtml += create_youtube_obj();
		//else 
		strHtml = strHtml.replace(strSelectionEditor, create_youtube_obj());
		ed.setContent(strHtml);*/
	}else{
		var strHtml = create_youtube_obj();
		tinyMCE.execInstanceCommand(ed.id, 'mceInsertContent', false, strHtml);
		//ed.execCommand('mceInsertContent', false, strHtml);
	}
}