/**
* Set the size for each page to load
*/
var pageSize = 25;

/**
* Variable for the current page
*/
var objNode = new Object();
var objNodeAuth = new Object();
var isload = false;
var idParent = '';
var arrNodeSelect = [];
var boolFlagReset = false;
var arrNodeAuth = {};

jQuery(function () {
	// First time, directly load
	objNode[''] = new Object();
	objNode['']['totalload'] = 0;
	objNode['']['currentPage'] = 0;
	loadTree('');
	// Append a scroll event handler to the container
	jQuery("#tree_page").scroll(function() {
		if( isload == false){
			checkscroll(jQuery(this));
		}
	});	
	jQuery("#acc_btn_auth img").click(function () {
		strAuth = this.id;	
		jQuery.each(arrNodeSelect, function(key, val) {
				jQuery("#" + val + " a" ).attr("class", "jstree-auth-" + strAuth);
				if(jQuery("#" + val).attr("class") == "jstree-closed"){
					objNodeAuth[val] = new Object();
					objNodeAuth[val]['auth'] = strAuth;
				}
				arrNodeAuth[val] = strAuth;				
		});
		var strAuth = JSON.stringify(arrNodeAuth);	
		jQuery("#page_auth_contents").val(strAuth);
		arrNodeSelect = [];
	});
});

// Appends
function appendTree(parent_id, val){
	var boolFlagReset = jQuery("#boolFlagReset").val();
	if(boolFlagReset == 1){
		//default auth 
		//val.auth = jQuery("#default_auth_contents").val();
		//parent auth
		parentClass = jQuery("#" + parent_id).find("a:first").attr("class");		
		myArray = parentClass.split('-');
		val.auth = myArray[2];
	}
	if(val.right_id - val.left_id > 1){
		if(parent_id == ""){
			jQuery("<li />")
				.attr("id", val.id)
				.attr("class", "jstree-closed")
				.html("<ins class='jstree-icon' style='cursor: pointer;' onclick = loadTreeChild('" + val.id + "')>&#160;</ins>")
				.append(jQuery("<a />")
						.attr("onclick", "clickNode(jQuery(this), event)")
						.attr("title", val.name)
						.attr("style", "cursor: pointer;")
						.attr("class", "jstree-auth-" + val.auth)
						.html(val.name)
				)
				.appendTo($("#tree_page_ul"));
		} else {
			jQuery("<li />")
				.attr("id", val.id)
				.attr("class", "jstree-closed")
				.html("<ins class='jstree-icon' style='cursor: pointer;' onclick = loadTreeChild('" + val.id + "')>&#160;</ins>")
				.append(jQuery("<a />")
						.attr("onclick", "clickNode(jQuery(this), event)")
						.attr("title", val.name)
						.attr("style", "cursor: pointer;")
						.attr("class", "jstree-auth-" + val.auth)
						.html(val.name)
				)
			.appendTo(jQuery("#" + parent_id));
				
			// add Auth Node
			if(typeof objNodeAuth[parent_id] !== "undefined" && typeof objNodeAuth[parent_id]['auth'] !== "undefined"){
				if(typeof objNodeAuth[val.id] === "undefined"){
					objNodeAuth[val.id] = new Object();
				}
				objNodeAuth[val.id]['auth'] = objNodeAuth[parent_id]['auth'];
			}
		}
	} else {
		if(parent_id == ""){
			jQuery("<li />")
				.attr("id", val.id)
				.attr("class", "jstree-leaf")
				.html("<ins class='jstree-icon' >&#160;</ins>")
				.append(jQuery("<a />")
						.attr("onclick", "clickNode(jQuery(this), event)")
						.attr("title", val.name)
						.attr("style", "cursor: pointer;")
						.attr("class", "jstree-auth-" + val.auth)
						.html(val.name)
				)
				.appendTo($("#tree_page_ul"));
		} else {
			jQuery("<li />")
				.attr("id", val.id)
				.attr("class", "jstree-leaf")
				.html("<ins class='jstree-icon'>&#160;</ins>")
				.append(jQuery("<a />")
						.attr("onclick", "clickNode(jQuery(this), event)")
						.attr("title", val.name)
						.attr("style", "cursor: pointer;")
						.attr("class", "jstree-auth-" + val.auth)
						.html(val.name)
				)
			.appendTo($("#" + parent_id));
		}
	}
}

function clickNode(obj, e)
{
	var evtobj = window.event? event : e;

	idNode = obj.parent().attr('id');
	intIndexNode = jQuery.inArray(idNode, arrNodeSelect);
	if(intIndexNode == -1){
		if(!(evtobj.ctrlKey)){
			arrNodeSelect = [];
			jQuery(".jstree-clicked").removeClass("jstree-clicked");
		}
		arrNodeSelect.push(idNode);
		obj.addClass("jstree-clicked");
	} else {
		arrNodeSelect.splice( intIndexNode ,1 );
		obj.removeClass("jstree-clicked");
	}
}

function loadTreeChild(parent_id)
{
	if(jQuery("#" + parent_id).hasClass("jstree-open") == false){		
		objNode[parent_id] = new Object();
		objNode[parent_id]['currentPage'] = 0;
		var rs = loadTree(parent_id);
		idParent = parent_id;
		jQuery("#" + parent_id).attr("class", "jstree-open");
	}else if(jQuery("#" + parent_id).hasClass("jstree-open") == true){
		jQuery("#" + parent_id).find("li").remove();
		jQuery("#" + parent_id).attr("class", "jstree-closed");
	}
}

// Loads the 
function loadTree(parent_id){
	getTotalNode(parent_id);
	strDefaultAuth = default_auth_contents;
	if(typeof objNodeAuth[parent_id] !== "undefined" && typeof objNodeAuth[parent_id]['auth'] !== "undefined"){
		strDefaultAuth = objNodeAuth[parent_id]['auth'];
	}
	
	var url =  path_system + 'contents/getchildren/ajax_request/true/count/' + pageSize + '/page/' + objNode[parent_id]['currentPage'] + '/parent_id/' + parent_id + '/default_auth/' + strDefaultAuth + '/account_id/' + account_id;
	jQuery.getJSON(url,function(data) {
		var totalLoadTemp = 0;
		jQuery.each(data, function(key, val) {		
			totalLoadTemp = key;
			appendTree(parent_id, val);
		 });
		objNode[parent_id]['totalload'] += totalLoadTemp + 1;
		// We're done loading so hide the overlay and update the UI
		$("#overlay").fadeOut();	
	});
	isload = false;
}

function getTotalNode(parent_id){
	var url =  path_system + 'contents/gettotalchildren/ajax_request/true/parent_id/' + parent_id;
	jQuery.getJSON(url,function(data) {
		objNode[parent_id]['total'] = data
	});
}

function checkscroll(obj){
	if ((obj[0].scrollHeight - obj.scrollTop()) + 2 == obj.outerHeight()) {
		if(objNode[idParent]['totalload'] < objNode[idParent]['total']){
			objNode[idParent]['currentPage'] ++;
			isload = true;
			$("#overlay").fadeIn();
			loadTree(idParent);
		} else {
			idParent = '';
		}
	}
}