/**
 * nj選択ボックス作成
 * @param object obj_top 作成対象のjQueryオブジェクト
 * @param object args    作成時に渡された引数
 */
function nj_create_select(obj_top, args) {
	var base_option = [];
	obj_top.find('option').each(function() {
		base_option.push({
			name  : jQuery(this).html(),
			value : jQuery(this).val()
		});
	});

	nj.create_object(
		obj_top,
		{
			args        : args,

			base_option : base_option,
			obj_root    : obj_top,

			load        : function (option) {
				var obj_select = this;

				if ('undefined' == typeof(option.url)) {
					option.url = this.args.url;
				}

				nj.record.get(option.url, function(record) {
					var record_list = eval('record.' + obj_select.args.list)

					// オプションを全て削除
					jQuery(obj_select.obj_root).find('option').remove();

					// ベースオプションを登録
					for (i = 0; i < obj_select.base_option.length; i ++) {
						obj_select.addOption(
							obj_select.base_option[i].name,
							obj_select.base_option[i].value
						);
					}

					// レコードオプションを登録
					for (i = 0; i < record_list.length; i ++) {
						option.callback(obj_select, record_list[i]);
					}
				});
			},
			addOption : function(name, value) {
				jQuery('<option title="' + name + '"></option>').appendTo(this.obj_root)
					.val(value)
					.html(name)
				;
			}
		}
	);
}
