var _doc = document;
var intContactForm = -1;
var intFormMailId = -1;

// 問い合わせ項目フォーム管理
function inquiryForm() {
	this.forms = null;

	// 問い合わせ管理のアイテム情報から問い合わせ項目情報を作成し、問い合わせ項目を表示する。
	this.view = function(form_data_only) {
		var i, formView, id;

		if (!this.forms) {
			this.forms = new Array();
			if ('' != _doc.getElementById('item').value) {
				// アイテム情報から問い合わせ項目情報を構築
				var formList;
				formList = _doc.getElementById('item').value.split("\n");
				for (i = 0; i < formList.length; i ++) {
					this.forms.push(new formData(formList[i]));
				}
			}
		}

		if (true != form_data_only) {
			// 項目フォーム表示
			_doc.getElementById('inqForm_view').innerHTML = '';
			for (i = 0; i < this.forms.length; i ++) {
				_doc.getElementById('inqForm_view').innerHTML += this.forms[i].createView() + '<br>';
			}
		}

		// 項目フォーム内用設定
		for (i = 0; i < this.forms.length; i ++) {
			this.forms[i].setForm();
		}

		// 問い合わせテンプレート追加ボタン表示
		_doc.getElementById('inqForm_insertButton').innerHTML = '';
		//check type of contact
		contactype = jQuery("input[name=type]:checked").val();		
		if(contactype == 2){
			_doc.getElementById('inqForm_insertButton').innerHTML += '<a href onclick="inq.insert(\'' + objTranslation.gettext('inquiryform_msg26') + '\');return false;">' + objTranslation.gettext('inquiryform_msg26') + '</a><br>';
		}
		 
		for (i = 0; i < this.forms.length; i ++) {
			id = this.forms[i].params.id;
			name = _doc.getElementById('inqForm_name_' + id).value;
			_doc.getElementById('inqForm_insertButton').innerHTML += '<a href onclick="inq.insert(\'' + name + '\');return false;">' + name + '</a><br>';
		}		
		
		
		
		_doc.getElementById('inqForm_method_insert').style.display = 'block';
		// 
		mail_multi_view();
	}

	//--------------------------------------------------------------------------
	// 問い合わせ項目を追加する。
	this.add = function() {
		if ('' == _doc.getElementById('inqForm_name').value) {
			alert(objTranslation.gettext('inquiryform_msg1'));
			jQuery('#inqForm_name').addClass('cms_error_class');
			return;
		}
		
		if(2 == _doc.getElementById('inqForm_type').value || 3 == _doc.getElementById('inqForm_type').value || 4 == _doc.getElementById('inqForm_type').value){
			if(jQuery.trim(_doc.getElementById('inqForm_list').value) == ''){
				alert(objTranslation.gettext('inquiryform_msg23'));
				jQuery('#inqForm_list').addClass('cms_error_class');
				return ;
			}
		}
		jQuery('[id^=inqForm_list]').each(function() {
			jQuery(this).removeClass('cms_error_class');
		});
		/*
		 * C-Unit 2011-12-08 start
		 * #6359
		 * Check character special
		 */
		bolValidText = validText(_doc.getElementById('inqForm_name').value);
		if(bolValidText == false)
		{
			alert(objTranslation.gettext('item_edit_dynamic_js_msg62'));
			jQuery('#inqForm_name').addClass('cms_error_class');
			return false;
		}
		jQuery('#inqForm_name').removeClass('cms_error_class');
		jQuery('#inqChoicesList').hide();
		/*
		 * C-Unit 2011-12-08 end
		 */
		// 新
		this.applyForm();
		// 次項目の ID を作成
		var i, id = 0;
		for (i = 0; i < this.forms.length; i ++) {
			if (id == this.forms[i].params.id) {
				i = -1;
				id ++;
				continue;
			}
		}
		// 追加内容を登録
		this.forms.push(new formData(null, id));
		// 追加項目フォーム初期化
		this.forms[0].initBaseForm();
		// 表示
		this.view();
	}

	// 問い合わせ項目を削除する。
	this.del = function(id) {
		// 更新
		this.applyForm();
		// 削除
		var i;
		for (i = 0; i < this.forms.length; i ++) {
			if (id == this.forms[i].params.id) {
				this.forms.splice(i, 1);
				break;
			}
		}
		// 表示
		this.view();
		
		/**
		 * Display add contact form button when remove contact block
		 */
		if(id == intContactForm){
			jQuery(".inq_addbtn").show();
			intContactForm = -1;
		}
	}

	// 問い合わせ項目を入れ替える。
	this.swap = function(id, change) {
		// 更新
		this.applyForm();
		// 入れ替え
		var i, stk;
		for (i = 0; i < this.forms.length; i ++) {
			if (id == this.forms[i].params.id) {
				stk = this.forms[i];
				break;
			}
		}
		// 移動出来ないなら終了
		if ('undefined' == typeof(this.forms[i + change])) return;
		// 入れ替え
		this.forms[i] = this.forms[i + change];
		this.forms[i + change] = stk;
		// 表示
		this.view();
	}

	// 問い合わせ管理のアイテム情報に問い合わせ項目情報を反映させる。
	this.applyForm = function() {
		var i, stk;

		// 項目フォーム情報更新
		for (i = 0; i < this.forms.length; i ++) {
			this.forms[i].set(null, this.forms[i].params.id);
		}

		// データベース保存用フォームの内容を更新
		_doc.getElementById('item').value = '';
		for (i = 0; i < this.forms.length; i ++) {
			if (0 != i) {
				_doc.getElementById('item').value += "\n";
			}
			_doc.getElementById('item').value += this.forms[i].getItem();
		}
	}
	//--------------------------------------------------------------------------

	// 問い合わせ管理での編集内容をデータベースに登録する。
	this.submit = function() {

		if (jQuery('#form_send_radio_multi').is('checked') && '' == jQuery('#mail_multi_title').val()) {
			alert(objTranslation.gettext('inquiryform_msg1'));
			jQuery('#mail_multi_title').addClass('cms_error_class');
			return false;
		}

		// 更新
		this.applyForm();

		var i, j;

		if (0 == document.getElementById('id_ok').options.length) {
			alert(objTranslation.gettext('inquiryform_msg2') + '/n' + objTranslation.gettext('inquiryform_msg17'));
			return false;
		}

	  /*
		 * C-Unit 2011-12-08 start
		 * #6359
		 * Check character special
		 */
		 for (i = 0; i < this.forms.length; i ++) {
			 	if(!_doc.getElementById('inqForm_name_' + i)){
					continue;
				}
				
				name = _doc.getElementById('inqForm_name_' + i).value;
				if(name == '')
				{
					alert(objTranslation.gettext('inquiryform_msg1'));
					jQuery('#inqForm_name_' + i).addClass('cms_error_class');
					return false;
				}
				
				bolValidText = validText(_doc.getElementById('inqForm_name_' + i).value);
				if(bolValidText == false)
				{
					alert(objTranslation.gettext('inquiryform_msg24'));
					jQuery('#inqForm_name_' + i).addClass('cms_error_class');
					return false;
				}
				/*if(2 == _doc.getElementById('inqForm_type_' + i).value || 3 == _doc.getElementById('inqForm_type_' + i).value || 4 == _doc.getElementById('inqForm_type_' + i).value){
					if(jQuery.trim(_doc.getElementById('inqForm_list_' + i).value) == ''){
						alert('[' + objTranslation.gettext('inquiryform_msg21') + ']' + objTranslation.gettext('inquiry_msg3'));
						jQuery('#inqForm_list_' + i).addClass('cms_error_class');
						return false;
					}
				}*/
		 }
		jQuery('[id^=inqForm_name_]').each(function() {
			jQuery(this).removeClass('cms_error_class');
		});
		/*
		 * C-Unit 2011-12-08 end
		 */
		// 受信用メール振り分け項目の数が２つ以上ある場合はエラー
		var mail_multi_count = 0;
		for (i = 0; i < this.forms.length; i ++) {
			if (8 == this.forms[i].params.type) {
				mail_multi_count ++;
				if (2 <= mail_multi_count) {
					alert(objTranslation.gettext('inquiryform_msg3'));
					return false;
				}
			}
		}

		// 振り分けモードの場合
		if (true == document.getElementById('form_send_radio_multi').checked) {
			// 受信用メール振り分け項目の数が０個の場合はエラー
			if (0 == mail_multi_count) {
				var msg = '';
				msg += objTranslation.gettext('inquiryform_msg4') + "\n";
				msg += objTranslation.gettext('inquiryform_msg5') + "\n";
				msg += objTranslation.gettext('inquiryform_msg6');
				alert(msg);
				return false;
			}
			// 選択肢名が重複している場合はエラー
			var arrName = [];
			jQuery('.mail_multi_tr').each(function() {
				arrName.push(jQuery(this).find('[id^=mail_multi_name_]').val());
			});
			for (i = 0; i < arrName.length; i ++) {
				for (j = i + 1; j < arrName.length; j ++) {
					if (arrName[i] == arrName[j]) {
						alert(objTranslation.gettext('inquiryform_msg7'));
						return false;
					}
				}
			}
		}

		var form = new formData();

		// 不要なフォームを送らないよう、フォームを無効にする
		form.disableForm(true, true);
		for (i = 0; i < this.forms.length; i ++) {
			this.forms[i].disableForm(true);
		}

		// サブミット処理実行
		var ret = cms.dbSet();

		// 失敗？
		if (false == ret) {
			// フォームを有効にする
			form.disableForm(false, true);
			for (i = 0; i < this.forms.length; i ++) {
				this.forms[i].disableForm(false);
			}
			// 振り分け区域描画
			mail_multi_view();
			this.view(true);
		}

		// 処理結果返却
		return ret;
	}

	// 問い合わせ項目の種類テンプレートを適用する。
	this.template = function(id, templateType) {
		var keyList, keyType;
		if ('inqForm_replace_id' == id) {
			keyList = 'inqForm_list';
			keyType = 'inqForm_type';
			ChoicesList = 'inqChoicesList';
		} else {
			keyList = 'inqForm_list_' + id;
			keyType = 'inqForm_type_' + id;
			ChoicesList = 'inqChoicesList_' + id;
		}

		var list = _doc.getElementById(keyList).value;
		var type = _doc.getElementById(keyType).options[_doc.getElementById(keyType).selectedIndex].value;

		// 問い合わせテンプレート構築
		{
			switch (type) {
			// テキスト,テキストエリア,チェックボックス
			// ラジオボタン,セレクトボックス,送信者メールアドレス
			case '0': case '1': case '2':
			case '3': case '4': 
				// 何もしない
				list = '';
				break;
			case '5':
				list = 'mail@example.co.jp';
				break;
			// 都道府県
			case '6':
				list = '';
				list += objTranslation.gettext('inquiryform_msg8');
				list += objTranslation.gettext('inquiryform_msg9');
				list += objTranslation.gettext('inquiryform_msg10');
				list += objTranslation.gettext('inquiryform_msg11');
				break;
			// 受信用メール振り分け
			case '8':
				list = mail_multi_namelist();
				break;
			// 性別
			case '7':
				list = objTranslation.gettext('inquiryform_msg12');
				break;
			case '10':
				list = '000123456';
				break;
			case '11':
				list = '090********';
				break;
				
			}
			// 登録
			_doc.getElementById(keyList).value = list;
		}
		
		loadBoxTitle(type, ChoicesList, templateType);

		this.applyForm();
		mail_multi_view();
		//this.view();
	}

	// 自動返信メール本文に問い合わせ項目ブロックを挿入する。
	this.insert = function(id) {
		/**
		 * C-Unit 2011-11-30
		 * #6268
		 * Change tag name @フォーム項目 to english
		 */
		//njText.insert('res_body', '{' + id + '@フォーム項目}');
		//njText.insert('res_body', '{' + id + objTranslation.gettext('inquiryform_msg13'));
		njText.insert('res_body', '{' + id + '@FieldName}');
	}

	this.update = function(obj) {
		// 問い合わせテンプレート追加ボタン表示
		var strCurrentListing = _doc.getElementById('inqForm_insertButton').innerHTML;
		var strCurrentBody = _doc.getElementById('res_body').value;

		_doc.getElementById('inqForm_insertButton').innerHTML = '';
		//check type of contact
		contactype = jQuery("input[name=type]:checked").val();		
		if(contactype == 2){
			_doc.getElementById('inqForm_insertButton').innerHTML += '<a href onclick="inq.insert(\'' + objTranslation.gettext('inquiryform_msg26') + '\');return false;">' + objTranslation.gettext('inquiryform_msg26') + '</a><br>';
		}
		
		for (i = 0; i < this.forms.length; i ++) {
			id = this.forms[i].params.id;
			
			// Update value at inquiry listing
			name = _doc.getElementById('inqForm_name_' + id).value;
			
			// If is exist name on the form, then return old value;
			if(obj.id != 'inqForm_name_' + id && obj.value == name){
				_doc.getElementById('inqForm_insertButton').innerHTML = strCurrentListing;
				_doc.getElementById('res_body').value = strCurrentBody;
				obj.value = obj.oldvalue;
				obj.focus();
				alert(objTranslation.gettext('inquiryform_msg14'));
				return false;
			}

			_doc.getElementById('inqForm_insertButton').innerHTML += '<a href onclick="inq.insert(\'' + name + '\');return false;">' + name + '</a><br>';

			// Update value in textarea
			if(obj.id == 'inqForm_name_' + id){
				oldName = _doc.getElementById('inqForm_name_' + id).oldvalue;
				if(oldName != '' && oldName != undefined && oldName != name){
					// replace all old name to new name
					/**
					 * C-Unit 2011-11-30 Start
					 * #6268
					 * Change tag name @フォーム項目 to english
					 */
					var intIndexOfMatch = _doc.getElementById('res_body').value.indexOf('{' + oldName + '@FieldName}');
					while (intIndexOfMatch != -1){
						_doc.getElementById('res_body').value = _doc.getElementById('res_body').value.replace('{' + oldName + '@FieldName}', '{' + name + '@FieldName}');
						intIndexOfMatch = _doc.getElementById('res_body').value.indexOf('{' + oldName + '@FieldName}');
					}
					/*
					var intIndexOfMatch = _doc.getElementById('res_body').value.indexOf('{' + oldName + '@フォーム項目}');
					while (intIndexOfMatch != -1){
						_doc.getElementById('res_body').value = _doc.getElementById('res_body').value.replace('{' + oldName + '@フォーム項目}', '{' + name + '@フォーム項目}');
						intIndexOfMatch = _doc.getElementById('res_body').value.indexOf('{' + oldName + '@フォーム項目}');
					}
					*/
					/**
					 * C-Unit 2011-11-30 End
					 */
					
				}
				//if(_doc.getElementById('mail_multi_title').value != name && intFormMailId == id){
				if(jQuery('#mail_multi_title').val() != name && intFormMailId == id){
					//_doc.getElementById('mail_multi_title').value = name;
					jQuery('#mail_multi_title').val(name);
				}
			}
		}
	}
	
	this.contactype = function(){
		contactype = jQuery("input[name=type]:checked").val();	
		if(contactype == 2)
		{
			jQuery(".inqType").append("<option value='9'>" + objTranslation.gettext('inquiryform_msg25')  + "</option>");				
		}else{
			checkVal = jQuery(".inqType option:selected").val();
			if( checkVal == 9){
				jQuery(".inqType").val(0)
			}
			$(".inqType option[value='9']").remove();			
		}
		// 表示
		this.view();
	}
}

// 問い合わせ項目情報管理
function formData(params, id) {
	// 項目フォーム情報構造
	this.keyType = {
		'id'        : 'text',
		'name'      : 'text',
		'type'      : 'select',
		'list'      : 'text',
		'annotation': 'text',
		'emptycheck': 'checkbox'
	};
	this.params = new Object();

	var key;
	for (key in this.keyType) {
		this.params[key] = '';
	}

	// 問い合わせ項目フォームを作成する
	this.createView = function() {
		var formView = _doc.getElementById('inqForm_base').innerHTML;

		formView = formView.replace(/inqForm_id/g, 'inqForm_id_' + this.params.id);
		formView = formView.replace(/inqForm_name/g, 'inqForm_name_' + this.params.id);
		formView = formView.replace(/inqForm_type/g, 'inqForm_type_' + this.params.id);
		formView = formView.replace(/inqForm_list/g, 'inqForm_list_' + this.params.id);
		formView = formView.replace(/inqForm_annotation/g, 'inqForm_annotation_' + this.params.id);
		formView = formView.replace(/inqForm_emptycheck/g, 'inqForm_emptycheck_' + this.params.id);

		formView = formView.replace(/inqForm_method_update/g, 'inqForm_method_update_' + this.params.id);
		formView = formView.replace(/inqForm_method_insert/g, 'inqForm_method_insert_' + this.params.id);
		formView = formView.replace(/項目/g, objTranslation.gettext('inquiryform_msg15'));

		formView = formView.replace(/inqForm_replace_id/g, this.params.id);
		
		formView = formView.replace(/inqChoicesList/g, 'inqChoicesList_' + this.params.id);

		return formView;
	}

	// 問い合わせ項目追加フォームの内容を初期化する
	this.initBaseForm = function() {
		var key, name;
		for (key in this.keyType) {
			name = 'inqForm_' + key;
			if (!_doc.getElementById(name)) continue;
			switch (this.keyType[key]) {
			case 'text':
				_doc.getElementById(name).value = '';
				break;
			case 'select':
				_doc.getElementById(name).selectedIndex = 0;
				break;
			case 'checkbox':
				_doc.getElementById(name).checked = 0;
				break;
			}
		}
	}

	// 問い合わせ項目フォームの disable フラグを設定する
	this.disableForm = function(flag, base) {
		var name, key;
		for (key in this.keyType) {
			name = 'inqForm_' + key;
			if (!base) name += '_' + this.params.id;
			if (!_doc.getElementById(name)) continue;
			_doc.getElementById(name).disabled = flag;
		}
	}

	// 問い合わせ項目フォームに情報を設定する
	this.setForm = function() {
		var i, key, name;

		for (key in this.keyType) {
			name = 'inqForm_' + key + '_' + this.params.id;					//alert(this.params[key]);
			if (!_doc.getElementById(name)) continue;
			
			switch (this.keyType[key]) {
			case 'text':
				_doc.getElementById(name).value = this.params[key];
				break;
			case 'select':
				for (i = 0; i < _doc.getElementById(name).options.length; i ++) {
					if (_doc.getElementById(name).options[i].value == this.params[key]) {
						_doc.getElementById(name).selectedIndex = i;
						loadBoxTitle(this.params[key], 'inqChoicesList_' + this.params.id, templateType);
						break;
					}
				}
				
				if(this.params[key] == 8){
					intFormMailId = this.params.id;
					viewMailListForm(this.params.id);
				}
				break;
			case 'checkbox':
				_doc.getElementById(name).checked = (1 == this.params[key]);
				break;
			}
		}

		_doc.getElementById('inqForm_method_update_' + this.params.id).style.display = 'block'
		_doc.getElementById('inqForm_method_insert_' + this.params.id).style.display = 'none'
	}

	// 問い合わせ項目フォームを更新する
	this.set = function(params, id) {
		var key;

		// パラメータ取得
		if (params) {
			// アイテム情報から構築
			if (null != params && (typeof(params) == "string" || params instanceof String)) {
				params = params.split("\t");
			}

			if (id) {
				params[0] = id;
			}

			var index;
			index = 0;
			for (key in this.keyType) {
				this.params[key] = params[index];
				index ++;
			}			
		}
		// DOM からパラメータ取得
		else {
			for (key in this.keyType) {
				name = 'inqForm_' + key;
				if ('undefined' != typeof(id)) {
					name += '_' + id;
				}
				if (!_doc.getElementById(name)) continue;
				switch (this.keyType[key]) {
				case 'text':
					this.params[key] = _doc.getElementById(name).value;
					break;
				case 'select':
					this.params[key] = _doc.getElementById(name).options[_doc.getElementById(name).selectedIndex].value;
					break;
				case 'checkbox':
					if (true == _doc.getElementById(name).checked) {
						this.params[key] = 1;
					} else {
						this.params[key] = 0;
					}
					break;
				}
			}
		}
	}

	// 問い合わせ管理のアイテム情報を取得する
	this.getItem = function() {
		var key, item = '';
		var first = true;
		for (key in this.keyType) {
			if (false == first) {
				item += "\t";
			}
			first = false;
			item += this.params[key];
		}
		return item;
	}

	if ('undefined' != typeof(params) && null != params) {
		this.set(params, id);
	} else {
		if ('undefined' != typeof(id)) {
			// 新規追加
			this.set();
			this.params.id = id;
		}
	}
}

/**
 * 振り分けモードの設定
 * @param string type 振り分けモードの指定「"normal"=振り分けない,"multi"=振り分ける」
 */
function form_send_change(type) {
	if ('normal' == type) {
		jQuery('#inq_mailedit01').show();
		jQuery('#inq_mailedit02').hide();

		jQuery('#form_send_normal').show();
		jQuery('#form_send_multi').hide();

		document.getElementById('form_send_radio_normal').checked = true;
		document.getElementById('form_send_radio_multi').checked = false;

		jQuery('#mail_multi_use').val('0');
	} else {
		jQuery('#inq_mailedit01').hide();
		jQuery('#inq_mailedit02').show();

		jQuery('#form_send_normal').hide();
		jQuery('#form_send_multi').show();

		document.getElementById('form_send_radio_normal').checked = false;
		document.getElementById('form_send_radio_multi').checked = true;

		jQuery('#mail_multi_use').val('1');
	}
}

/**
 * 振り分け受信行を追加
 */
function mail_multi_add() {
	var dt = new Date();
	var form_id = dt.getTime();

	var name = document.getElementById('mail_multi_name_(form_id)').value;
	var addr = document.getElementById('mail_multi_addr_(form_id)').value;

	var html = jQuery('#mail_multi_').html();
	html = html.split('(form_id)').join(form_id);

	var obj = jQuery('<tr class="mail_multi_tr" id="mail_multi_' + form_id + '">')
		.html(html)
		.insertBefore('#mail_multi_')
		.find('#del_btn').show().end()
		.find('#add_btn').hide().end()
	;
	jQuery('#mail_multi_name_' + form_id).val(name);
	jQuery('#mail_multi_addr_' + form_id).val(addr);

	document.getElementById('mail_multi_name_(form_id)').value = '';
	document.getElementById('mail_multi_addr_(form_id)').value = '';

	mail_multi_view();
	inq.view(true);
}

/**
 * 振り分け受信行を削除
 * @param string id 削除する振り分け受信行のID
 */
function mail_multi_del(id) {
	if ('mail_multi_(form_id)' == id) {
		var cnt = 0;
		jQuery('.mail_multi_tr').each(function() {
			if (-1 != this.id.indexOf('mail_multi_')) {
				cnt ++;
			}
		});
		var obj = jQuery('.mail_multi_tr').get(cnt - 2);

		document.getElementById('mail_multi_name_(form_id)').value = jQuery(obj).find('#' + obj.id.replace('mail_multi_', 'mail_multi_name_')).val();
		document.getElementById('mail_multi_addr_(form_id)').value = jQuery(obj).find('#' + obj.id.replace('mail_multi_', 'mail_multi_addr_')).val();

		jQuery(obj).remove();
	} else {
		jQuery('#' + id).remove();
	}

	mail_multi_view();
	inq.view(true);
}

/**
 * 受信用メール振り分け項目の名前リストを取得
 * @return string 受信用メール振り分け項目の名前リスト
 */
function mail_multi_namelist() {
	list = new Array();

	jQuery('[id^=mail_multi_name_]').each(function() {
		if ('' != list) {
			list += ',';
		}
		this.value = this.value.replace(',', '，');
		list += this.value;
	});

	return list;
}

/**
 * 問い合わせフォーム項目に「受信用メール振り分け項目」を追加
 */
function multi_list_create() {
	if ('' == jQuery('#mail_multi_title').val()) {
		alert(objTranslation.gettext('inquiryform_msg1'));
		jQuery('#mail_multi_title').addClass('cms_error_class');
		return;
	}
	if (false == validText(jQuery('#mail_multi_title').val()) || false == validSpecial(jQuery('#mail_multi_title').val())) {
		alert(objTranslation.gettext('inquiryform_msg24'));
		jQuery('#mail_multi_title').addClass('cms_error_class');
		return;
	}
	jQuery('#mail_multi_title').removeClass('cms_error_class');

	// 新
	inq.applyForm();
	// 次項目の ID を作成
	var i, id = 0;
	for (i = 0; i < inq.forms.length; i ++) {
		if (id == inq.forms[i].params.id) {
			i = -1;
			id ++;
			continue;
		}
	}

	// 追加内容を登録
	param = id;
	param += "\t" + jQuery('#mail_multi_title').val();
	param += "\t" + 8;
	param += "\t" + mail_multi_namelist();
	param += "\t" + '';
	param += "\t" + '0';
	inq.forms.splice(0, 0, new formData(param, id));

	// 追加項目フォーム初期化
	inq.forms[0].initBaseForm();

	// 表示
	inq.view();

	/**
	 * Disable contact emails.
	 */
	viewMailListForm(id);
}

/**
 * View contact mail list form
 */
function viewMailListForm(id)
{
	if(!intContactForm || intContactForm < 0){
		intContactForm = id;
	}
	if(intContactForm == id){
		_doc.getElementById('inqForm_list_' + id).disabled = true;
		_doc.getElementById('inqForm_type_' + id).disabled = true;
		var select = _doc.getElementById('inqForm_type_' + id);
		select.options[select.options.length] = new Option(objTranslation.gettext('inquiryform_msg18'), '8', 'selected', 'selected');
		jQuery('#inqChoicesList_' + id).show();
		jQuery('#inqChoicesList_' + id + ' .cnt_itmleft01').html(objTranslation.gettext('inquiryform_msg21'));
		jQuery('#inqChoicesList_' + id + ' .ex').html(objTranslation.gettext('inquiryform_msg19'));
		jQuery('.inq_addbtn').hide();
	}
}
/**
 * Show hide 「選択肢」 box on PC.
 */
function loadBoxTitle(intType, strChoicesList, strTemplateType){

	if(strTemplateType == 'smp'){
		switch (intType) {
			case '2': case '3': case '4': case '8':
				jQuery('#' + strChoicesList).show();
				jQuery('#' + strChoicesList + ' .cnt_itmleft01').html(objTranslation.gettext('inquiryform_msg21'));
				jQuery('#' + strChoicesList + ' .ex').html(objTranslation.gettext('inquiryform_msg19'));
				break;
			case '0': case '1': case '10': case '11':
				jQuery('#' + strChoicesList).show();
				jQuery('#' + strChoicesList + ' .cnt_itmleft01').html(objTranslation.gettext('inquiryform_msg22'));
				jQuery('#' + strChoicesList + ' .ex').html(objTranslation.gettext('inquiryform_msg20'));
				break;
			case '5':
				jQuery('#' + strChoicesList).show();
				jQuery('#' + strChoicesList + ' .cnt_itmleft01').html(objTranslation.gettext('inquiryform_msg22'));
				jQuery('#' + strChoicesList + ' .ex').html(objTranslation.gettext('inquiryform_msg20'));
				break;
			default:
				jQuery('#' + strChoicesList).hide();
		}
	}else{
		switch (intType) {
			case '2': case '3': case '4':
				jQuery('#' + strChoicesList).show();
				jQuery('#' + strChoicesList + ' .cnt_itmleft01').html(objTranslation.gettext('inquiryform_msg21'));
				jQuery('#' + strChoicesList + ' .ex').html(objTranslation.gettext('inquiryform_msg19'));
				break;
			case '8':
				jQuery('#' + strChoicesList).show();
				jQuery('#' + strChoicesList + ' .cnt_itmleft01').html(objTranslation.gettext('inquiryform_msg22'));
				jQuery('#' + strChoicesList + ' .ex').html(objTranslation.gettext('inquiryform_msg20'));
				break;
			case '16':				
				jQuery('#' + strChoicesList + ' .cnt_itmleft01').html(objTranslation.gettext('inquiryform_msg22'));			
				break;
			default:
				$('#' + strChoicesList).hide();
		}
	}
}
/**
 * 受信用メール振り分け項目のフォームにある名前リストを更新
 */
function multi_list_formupdate() {
	var i;

	for (i = 0; i < inq.forms.length; i ++) {
		if (8 == inq.forms[i].params.type) {
			inq.forms[i].params.list = mail_multi_namelist();

			// 
			index = _doc.getElementById('inqForm_type_' + inq.forms[i].params.id).selectedIndex;
			if (8 == _doc.getElementById('inqForm_type_' + inq.forms[i].params.id).options[index].value) {
				_doc.getElementById('inqForm_list_' + inq.forms[i].params.id).disabled = true;
			} else {
				_doc.getElementById('inqForm_list_' + inq.forms[i].params.id).disabled = false;
			}
			jQuery('#inqForm_name_' + inq.forms[i].params.id).val(jQuery('#mail_multi_title').val());
			inq.update(_doc.getElementById('inqForm_name_' + inq.forms[i].params.id)); 
			_doc.getElementById('inqForm_name_' + inq.forms[i].params.id).oldvalue = _doc.getElementById('inqForm_name_' + inq.forms[i].params.id).value; 
		}
	}

	index = _doc.getElementById('inqForm_type').selectedIndex;
	if (8 == _doc.getElementById('inqForm_type').options[index].value) {
		_doc.getElementById('inqForm_list').disabled = true;
	} else {
		_doc.getElementById('inqForm_list').disabled = false;
	}

}

/**
 * 受信用メール振り分けの編集フォームを表示する
 * @param boolean error_view エラー表示を行うかどうか(true=行う,その他=行わない)
 */
function mail_multi_view(error_view) {
	var cnt = 0;

	jQuery('.mail_multi_tr').each(function() {
		if (-1 != this.id.indexOf('mail_multi_')) {
			cnt ++;
		}
	});

	if (1 == cnt) {
		jQuery('#mail_multi_').find('#del_btn').hide();
		jQuery('#mail_multi_').find('#add_btn').show();
	} else {
		jQuery('#mail_multi_').find('#del_btn').show();
		jQuery('#mail_multi_').find('#add_btn').show();
	}

	multi_list_formupdate();

	if (true == error_view) {
		jQuery('.mail_multi_tr').each(function() {
			if (0 == this.id.indexOf('mail_multi_')) {
				var obj, id;

				obj = jQuery(this).find('[id^=mail_multi_name_]');
				if ('' == obj.val()) {
					id = obj.attr('id').split('(').join('\\(').split(')').join('\\)');
					cms.setFormError(id, '');
				}
				obj = jQuery(this).find('[id^=mail_multi_addr_]');
				if ('' == obj.val()) {
					id = obj.attr('id').split('(').join('\\(').split(')').join('\\)');
					cms.setFormError(id, '');
				}
			}
		});
	}
}