/**
 * 監視オブジェクト作成
 * @param object obj_top 作成対象のjQueryオブジェクト
 * @param object args    作成時に渡された引数
 */
njWatch = function() {
	this.interval_list = {};
	this.interval_id;

	/* オプション
	data     
	target   
	check    
	interval 
	match    
	unmatch  
	*/

	this.create = function(option) {
		this.interval_list[option.id] = option;

		if (null == this.interval_id) {
			this.interval_id = setInterval('nj.watch.main();', 1000);
		}
	}
	this.remove = function(id) {
		this.interval_list[id] = null;
	}

	this.main = function() {
		var id, key;
		var obj;
		var match;

		var new_list = [];
		for (id in this.interval_list) {
			obj = this.interval_list[id];
			if (null == obj) {
				continue;
			}

			match = true;
			for (key in obj.check) {
				if (obj.target.css(key) != obj.check[key]) {
					match = false;
					break;
				}
			}
			if (match) {
				if (null != obj.match) {
					obj.match(obj.data);
				}
			} else {
				if (null != obj.unmatch) {
					obj.unmatch(obj.data);
				}
			}

			new_list.push(this.interval_list[id]);
		}

		this.interval_list = new_list;

		if (0 == this.interval_list.length) {
			clearInterval(this.interval_id);
			this.interval_id = null;
		}
	}
}
